#include <stdio.h>
#include <assert.h>
#include "parti.h"

/*==========================================================================*/
SCHED *schedule(local,proc,ndata,maxdim)
int *local,*proc,ndata,maxdim;
{
  int *bl,*pl,**perms,**buckets,*bsize;
  int *GColor;
  struct com_pattern *sr;
  SCHED *sched;
  int   i;
 
#ifdef DEBUG 
  trace_enter("schedule");
#endif
  sched		= (SCHED *) malloc(sizeof(SCHED));
  bl		= (int *) malloc(sizeof(int)*ndata);
  pl		= (int *) malloc(sizeof(int)*ndata);
  perms		= (int **) malloc(sizeof(int *)*PARTI_numnodes);
  buckets	= (int **) malloc(sizeof(int *)*PARTI_numnodes);
  bsize		= (int *) malloc(sizeof(int)*PARTI_numnodes);
  sched->global_refs = NULL;
  sched->local_refs = NULL;
  sched->type = NORMAL;
  bsort(PARTI_numnodes,ndata,proc,local,bsize,buckets,perms,bl,pl);
  sr = schedule_gather(bsize,buckets,maxdim);

  GColor  = (int *) malloc(sizeof(int)*PARTI_numnodes);
  PairColor(GColor, PARTI_mynode);
  sr->gcolor    = GColor;

  sched->sr 	= sr;
  sched->perm 	= pl;
  sched->size	= NULL;
  sched->ndata 	= ndata;

  free(perms);
#ifdef DEBUG
  trace_exit();
#endif
  return(sched);
}
/*==========================================================================*/
SCHED *schedulen(local,proc,global,lcl,ndata,maxdim)
int *local,*proc,ndata,*global,*lcl,maxdim;
{
  int *bl,*pl,**perms,**buckets,*bsize;
  int *GColor;
  struct com_pattern *sr;
  SCHED *sched;
  int   i;
 
#ifdef DEBUG 
  trace_enter("schedule");
#endif
  sched		= (SCHED *) malloc(sizeof(SCHED));
  bl		= (int *) malloc(sizeof(int)*ndata);
  pl		= (int *) malloc(sizeof(int)*ndata);
  sched->global_refs = (int *) malloc(sizeof(int)*ndata);
  sched->local_refs = (int *) malloc(sizeof(int)*ndata);
  sched->type = NORMAL;
  assert ( bl && pl && sched->global_refs && sched->local_refs );

  perms		= (int **) malloc(sizeof(int *)*PARTI_numnodes);
  buckets	= (int **) malloc(sizeof(int *)*PARTI_numnodes);
  bsize		= (int *) malloc(sizeof(int)*PARTI_numnodes);

  assert ( perms && buckets && bsize );

  bsort(PARTI_numnodes,ndata,proc,local,bsize,buckets,perms,bl,pl);
  sr = schedule_gather(bsize,buckets,maxdim);

  GColor  = (int *) malloc(sizeof(int)*PARTI_numnodes);
  PairColor(GColor, PARTI_mynode);
  sr->gcolor    = GColor;

  sched->sr 	= sr;
  sched->perm 	= pl;
  sched->size 	= pl;
  sched->ndata 	= ndata;
  for(i=0;i<ndata;i++){
      sched->global_refs[i] = global[i];
      sched->local_refs[i] = lcl[i];
  }

  free(perms);
#ifdef DEBUG
  trace_exit();
#endif
  return(sched);
}
/*==========================================================================*/

SCHED *ischedule(local,proc,ndata,offset_table,proc_table)
int *local,*proc,ndata,*offset_table,*proc_table;
{
  SCHED *sr,*sr1;
  int *local_deref,*proc_deref;
#ifdef DEBUG 
  trace_enter("ischedule");
#endif
  local_deref = (int *) malloc(sizeof(int)*ndata);
  proc_deref = (int *) malloc(sizeof(int)*ndata);
 
  sr1 = schedule(local,proc,ndata,1);
  PARTI_gather(sr1,local_deref,offset_table,sizeof(int));
  PARTI_gather(sr1,proc_deref,proc_table,sizeof(int));
  sr = schedule(local_deref,proc_deref,ndata,1);
  return(sr);
#ifdef DEBUG 
  trace_exit();
#endif
}

/*==============================================================*/
void
  free_sched(sched)
SCHED *sched;
{
struct com_pattern *pattern;
int node;

pattern = sched->sr;

for(node=0; node<PARTI_numnodes; node++) {
  if (pattern->send_n[node] > 0 && pattern->send_list ) {
    if (pattern->send_list[node] != NULL) {
       free(pattern->send_list[node]);
       pattern->send_list[node] = NULL;
    }
  }
}

if (pattern->fetch_list) free(pattern->fetch_list[0]);
if (pattern->fetch_list) free(pattern->fetch_list);
if (pattern->send_list)  free(pattern->send_list);
if (pattern->send_n)	 free(pattern->send_n);
if (pattern->send_n)	 free(pattern->fetch_n);
if (pattern->send_size)  free(pattern->send_size);
if (pattern->fetch_size) free(pattern->fetch_size);
if (pattern->gcolor)     free(pattern->gcolor);
free(pattern);

if(sched->global_refs)   free(sched->global_refs);
if(sched->local_refs)    free(sched->local_refs);
if(sched->size)          free(sched->size);
free(sched->perm);
free(sched);
}
/*==============================================================*/

